"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const common_2 = require("../../common");
const constants_1 = require("../../common/constants");
const dashboard_entity_1 = require("./entities/dashboard.entity");
const wusergrp_service_1 = require("../../auth/wusergrp/wusergrp.service");
let DashboardService = class DashboardService extends common_2.BaseService {
    constructor(model, dashboard, role, userGroupService) {
        super(model);
        this.model = model;
        this.dashboard = dashboard;
        this.role = role;
        this.userGroupService = userGroupService;
    }
    findAll(code) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log("Finding Usergroup with code");
            const userGroup = yield this.userGroupService.findOne(code);
            const wusrid = userGroup.get({ plain: true });
            console.log('Result User', wusrid);
            console.log("Dashboard IDs", wusrid.wug_dashboardids);
            if (wusrid.wug_dashboardids != null) {
                const did = wusrid.wug_dashboardids.split(',');
                const dashid = yield this.dashboard.findAll({
                    where: { id: did },
                    raw: true
                });
                console.log('Gettin Dashboard', dashid);
                return dashid;
            }
            else {
                return [];
            }
        });
    }
    exec(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const dashboard = yield this.dashboard.findOne({
                where: { id: id },
            });
            if (dashboard) {
                const result = yield this.queryExecute(dashboard.value);
                return result;
            }
            else {
                return null;
            }
        });
    }
    popquery(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const dashid = yield this.dashboard.findOne({
                where: { id: id },
            });
            if (dashid) {
                const query = yield this.queryExecute(dashid.popquery);
                return query;
            }
            else {
                return null;
            }
        });
    }
    queryExecute(query) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.dashboard.sequelize.query(query);
        });
    }
};
DashboardService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(constants_1.DASHBOARD)),
    __param(1, common_1.Inject(constants_1.DASHBOARD)),
    __param(2, common_1.Inject(constants_1.CORE_ROLES)),
    __metadata("design:paramtypes", [dashboard_entity_1.Dashboard, Object, Object, wusergrp_service_1.WusergrpService])
], DashboardService);
exports.DashboardService = DashboardService;
